#include "chess.h"

//Zhlvariablen initialisieren       
volatile uint8_t seconds[] = {0,0};
volatile uint8_t minutes[] = {0,0};
volatile uint8_t mseconds[] = {0,0};
volatile uint8_t updateDisplay = 0;

volatile uint8_t current = 0;
unsigned long Timer = 0;

//Andere Variablen
uint8_t Intensity = 80;



void ChessInit(void)
{
    //Init MAX7219
    SPIMasterInit();
    SetMode(MAX_MODE_NORMAL);
    SetIntensity(Intensity / 10);
    SetDecodeMode(0x00);
    SetScanLimit(0x07);
    SetAll(0);
    
    //Init ADC
    ADCInit();
    
    //8bit Timer Init
    TCCR0 = (1<<CS00);          //Kein Teiler
    TIMSK |= (1<<TOIE0);        // Overflow Interrupt erlauben
    sei();                      // Global Interrupts aktivieren
}

void PlayManual(uint16_t sec1,uint16_t sec2)
{
    SetTime(0,sec1);
    SetTime(1,sec2);
    //KeyTest();
    updateDisplay = 1; 
    Timer = 0;
    while(1) 
    {    
        uint8_t key = GetKey();
        if(key != 255)
        SetDigit(0,chars[key]);
        switch(key)
        {
            case 1: current = 0;
            break;
            case 7: current = 1;
            break;
            case 4:
                if(Intensity < 0x0F * 10)
                { 
                    Intensity++;   
                    SetIntensity(Intensity / 10);
                }
                break;
           case 6:
                if(Intensity > 0x00)
                { 
                    Intensity--;   
                    SetIntensity(Intensity / 10);
                }
                break;
        };
        if(key == 1)
        current  =0;
        if(updateDisplay == 1 ) 
        {
            // die aktuelle Uhrzeit holen. Dabei aber dafr sorgen
            // dass sich die nicht schnell mal ndern kann
            cli();
            updateDisplay = 0;

            // ab jetzt haben wir alle Zeit der Welt die Zeit auf
            // die Anzeige zu bringen
            for(uint8_t i = 0; i != 2; i++)
            {
                SetDigit( 3 + 4*i, chars[seconds[i] % 10] );
                SetDigit( 2 + 4*i, chars[seconds[i] / 10] );
                SetDigit( 1 + 4*i, chars[minutes[i] % 10] + 128 ); // + 128 fr den Trennpunkt
                //SetDigit( 0 + 4*i, chars[minutes[i] / 10] );
            }
            sei();
        }
    }
}

void SetTime(uint8_t player, uint16_t time)
{
    minutes[player] = time / 60;
    seconds[player] = time - minutes[player] * 60;   
}

ISR (TIMER0_OVF_vect)
{
    Timer += 256;
    if (Timer >= F_CPU / 10)
    {
        Timer -= F_CPU / 10;
        mseconds[current]--; 
        updateDisplay = 1;
        if(mseconds[current] == 255)
        {
            mseconds[current] = 9;
            seconds[current]--;                      
            if( seconds[current] == 255 ) 
            {
                seconds[current] = 59;
                minutes[current]--;
                if( minutes[current] == 255 ) 
                {
                    minutes[current] = 59;
                    Lost(current);
                }
            }
            updateDisplay = 1;
        }
    }
}

void Lost(uint8_t player)
{
    uint8_t screen = 1;
    while(1)
    {
        for(int i = 0; i != 4; i++)
            SetDigit(i + player*4, screen);
        screen = 1 - screen;
        _delay_ms(500);
    }
}
